﻿Imports System.Data.Entity
Imports System.Data.Entity.Infrastructure
Imports System.Data.Entity.SqlServer
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Management
Imports System.Text
Imports System.Threading
Imports System.Threading.Tasks
Imports System.Transactions
Imports CasinoSolution.Repository
Imports MSDNEF6Article.DataLayer
Imports DomainClasses
Imports HibernatingRhinos.Profiler.Appender.EntityFramework
Imports Microsoft.VisualStudio.TestTools.UnitTesting

Namespace AutomatedTests
    <TestClass>
    Public Class UnitTest1
        <TestMethod, TestCategory("Pluralization")>
        Public Sub PluralizationService_pluralize_names_taken_from_DbSet_property_type_names()
            Using context = New CasinoSlotsModel()
                Assert.AreEqual("Casinos", UnitTestHelpers.GetEntitySetTableName(context, GetType(Casino)))
                Assert.AreEqual("Statii", UnitTestHelpers.GetEntitySetTableName(context, GetType(Status)))
            End Using
        End Sub

        <TestMethod, TestCategory("Pluralization")>
        Public Sub PluralizationService_CreatesCorrectNamesInDatabaseForCodeFirst()
            Database.SetInitializer(New DropCreateDatabaseIfModelChanges(Of CasinoSlotsModel)())
            Dim sql As String = "select @tablecount=count(table_name) from INFORMATION_SCHEMA.Tables where table_name=@tablename"

            Using context = New CasinoSlotsModel()
                Dim p As SqlParameter = UnitTestHelpers.CountDbTables(context, sql, "Casinos")
                Assert.AreEqual(1, p.Value, "Casino")
                p = UnitTestHelpers.CountDbTables(context, sql, "Statii")
                Assert.AreEqual(1, p.Value, "Status")
                p = UnitTestHelpers.CountDbTables(context, sql, "FrenchJournaux")
                Assert.AreEqual(1, p.Value, "FrenchJournal")
            End Using
        End Sub
    End Class
End Namespace