﻿Imports System.Data.Entity
Imports System.Data.Entity.Core.Metadata.Edm
Imports System.Data.Entity.Infrastructure
Imports System.Data.Entity.Infrastructure.Pluralization
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Management
Imports System.Security.Principal
Imports System.Threading.Tasks
Imports CasinoSolution.Repository
Imports MSDNEF6Article.DataLayer
Imports DomainClasses

Namespace AutomatedTests
    Public NotInheritable Class UnitTestHelpers
        Friend Shared Function GetEntitySetTableName(ByVal dbContext As DbContext, ByVal clrType As Type) As String
            Dim objectContext = (CType(dbContext, IObjectContextAdapter)).ObjectContext
            Dim container = objectContext.MetadataWorkspace.GetItems(Of EntityContainer)(DataSpace.SSpace).SingleOrDefault()

            If container Is Nothing Then
                Return Nothing
            End If

            Dim entitySet = container.BaseEntitySets.Where(Function(bes) bes.ElementType.Name = clrType.Name).SingleOrDefault()
            If entitySet Is Nothing Then
                Return Nothing
            End If

            Return entitySet.Table
        End Function
        Friend Shared Function CountDbTables(ByVal context As CasinoSlotsModel, ByVal sql As String, ByVal name As String) As SqlParameter
            Dim p = New SqlParameter With {.ParameterName = "@tablecount", .DbType = DbType.Int32, .Size = 1, .Direction = ParameterDirection.Output}
            context.Database.ExecuteSqlCommand(sql, New SqlParameter("@tableName", name), p)
            Return p
        End Function
    End Class
End Namespace