﻿Imports System.Data.Common
Imports System.Data.Entity
Imports System.Data.Entity.Migrations.History
Imports DomainClasses
'using System.Data.Entity.Config;

'using DateTimePropertyConfiguration = System.Data.Entity.ModelConfiguration.Configuration.Properties.Primitive.DateTimePropertyConfiguration;

Namespace MSDNEF6Article.DataLayer
    Public Class CasinoSlotsModel
        Inherits DbContext
        Public Sub New(ByVal connectionStringName As String)
            MyBase.New(connectionStringName)
        End Sub

        Sub New()
            ' TODO: Complete member initialization 
        End Sub

        Public Property Casinos() As DbSet(Of Casino)
        Public Property SlotMachines() As DbSet(Of SlotMachine)
        Public Property PokerTables() As DbSet(Of PokerTable)
        Public Property Status() As DbSet(Of Status)
        Public Property Journaux() As DbSet(Of FrenchJournal)

        Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
            MyBase.OnModelCreating(modelBuilder)

            modelBuilder.Entity(Of PokerTable)().Property(Function(c) c.SerialNo).HasColumnType("nvarchar")
            modelBuilder.Properties().Where(Function(p) p.PropertyType Is GetType(String)).Configure(Function(p) p.HasColumnType("nvarchar"))
            modelBuilder.HasDefaultSchema("Casino")
            MyBase.OnModelCreating(modelBuilder)
        End Sub
    End Class

    Public Class MyInitializer
        Inherits DropCreateDatabaseAlways(Of CasinoSlotsModel)
        Protected Overrides Sub Seed(ByVal context As CasinoSlotsModel)
            Dim casino = New Casino With {.Description = "Bets are on!", .Name = "Gamble It Away", .Rating = CasinoRating.Nice}
            casino.SlotMachines.Add(New SlotMachine With {.DateInService = Date.Now, .SerialNumber = "123456", .SlotMachineType = SlotMachineType.BuyAPay})
            context.Casinos.Add(casino)
            Dim casino2 = New Casino With {.Description = "We are shiny!", .Name = "Harrahs", .Rating = CasinoRating.JustLikeonTv}
            casino2.SlotMachines.Add(New SlotMachine With {.DateInService = Date.Now, .SerialNumber = "654321", .SlotMachineType = SlotMachineType.BuyAPay})
            casino2.SlotMachines.Add(New SlotMachine With {.DateInService = Date.Now, .SerialNumber = "789111", .SlotMachineType = SlotMachineType.BuyAPay})

            context.Casinos.Add(casino2)
            MyBase.Seed(context)
        End Sub
    End Class

    Public Class MyHistoryContext
        Inherits HistoryContext
        Public Sub New(ByVal dbConnection As DbConnection, ByVal defaultSchema As String)
            MyBase.New(dbConnection, defaultSchema)
        End Sub

        Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
            MyBase.OnModelCreating(modelBuilder)
            modelBuilder.Entity(Of HistoryRow)().ToTable("__MigrationHistory", "admin")
        End Sub
    End Class
End Namespace