﻿Imports System.Data.Common
Imports System.Threading.Tasks

Imports DomainClasses
Imports System.Data.Entity
Imports MSDNEF6Article.DataLayer

Namespace CasinoSolution.Repository
    Public Class SimpleRepository
        Private _context As CasinoSlotsModel

        Public Sub New()
            _context = New CasinoSlotsModel
        End Sub

        Public Sub New(ByVal connectionStringName As String)
            _context = New CasinoSlotsModel(connectionStringName)
        End Sub

        Public Sub New(ByVal openDbConnection As DbConnection)
            _context = New CasinoSlotsModel
        End Sub

        Public Function GetAllCasinos() As List(Of Casino)
            Return _context.Casinos.ToList()
        End Function

        Public Async Function GetAllCasinosAsync() As Task(Of List(Of Casino))
            Return Await _context.Casinos.ToListAsync()
        End Function
        Public Function GetCasinoNotAsync(ByVal id As Integer) As Casino
            Return _context.Casinos.Find(id)

        End Function
        Public Async Function GetCasinoAsync(ByVal id As Integer) As Task(Of Casino)
            Return Await _context.Casinos.FindAsync(id)
        End Function
        Public Function IncrementCasinoRating(ByVal id As Integer) As CasinoRating

            Dim casino = _context.Casinos.Find(id)
            UpdateRating(casino)
            _context.SaveChanges()
            Return casino.Rating
        End Function
        Public Async Function IncrementCasinoRatingAsync(ByVal id As Integer) As Task(Of CasinoRating)


            Dim casino = Await _context.Casinos.FindAsync(id)
            ' Rest is delayed until awaited query has received results
            UpdateRating(casino)
            Await _context.SaveChangesAsync()
            '  Method completion is delayed until awaited SaveChanges has received results
            Return casino.Rating

        End Function

        Private Sub UpdateRating(ByVal casino As Casino)
            Select Case casino.Rating
                Case CasinoRating.Meh
                    casino.Rating = CasinoRating.Nice
                Case CasinoRating.Nice
                    casino.Rating = CasinoRating.JustLikeonTv
                Case CasinoRating.JustLikeonTv
                    casino.Rating = CasinoRating.Meh
                Case Else
                    Throw New ArgumentOutOfRangeException()
            End Select
        End Sub

        Public Function FindCasinosByRatingFromArray(ByVal r() As CasinoRating) As List(Of Casino)
            _context.Database.Log = Sub(s) Console.Write(s)
            Return _context.Casinos.Where(Function(c) r.Contains(c.Rating)).ToList()
        End Function
    End Class
End Namespace
