﻿Imports System.Data.Entity.Infrastructure.Pluralization
Namespace DataLayer.Pluralization
Public Class CustomPluralizationService
	Implements IPluralizationService
  Private ReadOnly baseService As IPluralizationService = New EnglishPluralizationService()
  Public Shared PluralWords As New List(Of String)()

  Public Function Pluralize(ByVal word As String) As String
	If word.EndsWith("ou") Then
	  Dim newWord As String = String.Format("{0}z", word)
	  PluralWords.Add(newWord)
	  Return newWord
	End If
	If word.EndsWith("us") Then
	  Dim newWord As String = String.Format("{0}ii", word.Remove(word.Length - 2))
	  PluralWords.Add(newWord)
	  Return newWord
	End If
	If word.StartsWith("French") AndAlso word.EndsWith("al") Then
	  Dim newWord As String = String.Format("{0}aux", word.Remove(word.Length - 2))
	  PluralWords.Add(newWord)
	  Return newWord
	End If

	'do not reprocess words that are already converted
	'this is happening as a result of calling the baseservice
	If Not PluralWords.Contains(word) Then
	  Return baseService.Pluralize(word)
	End If
	Return word
  End Function

  Public Function Singularize(ByVal word As String) As String
	Return word
  End Function
End Class
End Namespace
