﻿Imports DomainClasses.Infrastructure

Namespace DomainClasses
    Public Class Casino
        Public Sub New()
            SlotMachines = New List(Of SlotMachine)()
        End Sub
        Public Property Id() As Integer
        Public Property Name() As String
        Public Property Rating() As CasinoRating
        Public Property Description() As String
        Public Property SlotMachines() As ICollection(Of SlotMachine)
        Public Property PhysicalAddress() As Address
        Public Property MailingAddress() As Address
        Public Property OpeningDate() As Date
        Public Property SomeNewProperty() As String
        Public Property SomeOtherNewProperty() As String
        Public Property AgainSomeNewProperty() As String

        Public Class Address
            Inherits ValueObject(Of Address)
            Public Sub New(ByVal streetOrPoBox As String, ByVal city As String, ByVal state As String, ByVal postalCode As String)
                Me.City = city
                Me.State = state
                Me.PostalCode = postalCode
                Me.StreetOrPoBox = streetOrPoBox
            End Sub

            Private privateStreetOrPoBox As String
            Public Property StreetOrPoBox() As String
                Get
                    Return privateStreetOrPoBox
                End Get
                Private Set(ByVal value As String)
                    privateStreetOrPoBox = value
                End Set
            End Property
            Private privateCity As String
            Public Property City() As String
                Get
                    Return privateCity
                End Get
                Private Set(ByVal value As String)
                    privateCity = value
                End Set
            End Property
            Private privateState As String
            Public Property State() As String
                Get
                    Return privateState
                End Get
                Private Set(ByVal value As String)
                    privateState = value
                End Set
            End Property
            Private privatePostalCode As String
            Public Property PostalCode() As String
                Get
                    Return privatePostalCode
                End Get
                Private Set(ByVal value As String)
                    privatePostalCode = value
                End Set
            End Property
        End Class
    End Class

    Public Enum CasinoRating
        Meh = 1
        Nice = 2
        JustLikeonTv = 3
    End Enum
End Namespace
